// Status.cpp : implementation file
//

#include "stdafx.h"
#include "Status.h"
#include "HSL.h"
#include <Math.h> //For Sin & cos when Painter=Circular

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStatus

BEGIN_MESSAGE_MAP(CStatus, CWnd)
  //{{AFX_MSG_MAP(CWnd)
  ON_WM_PAINT()
  ON_WM_ERASEBKGND()
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStatus message handlers

BOOL CStatus::OnEraseBkgnd(CDC* pDC) {return TRUE;}//CStatic::OnEraseBkgnd(pDC);}

void CStatus::OnPaint() {
  if(!PixelLimit) FindPixelLimit();
  switch(Painter) {
    case Bar: {
      CPaintDC dcPaint(this);
      CMemDC dc(dcPaint,&Bitmap);

      Rect.left=Rect.right;  //Right hand side
      Rect.right=PixelLimit;

      dc.FillSolidRect(&Rect, GetSysColor(COLOR_3DFACE)); //Draw in dialogs background colour

      CRgn Region;
      Region.CreateRectRgn(Rect.left, Rect.top, Rect.right, Rect.bottom);
      dc.SelectClipRgn(&Region);

      CString s;
      GetWindowText(s);

      class CUseDialogFont {
        CGdiObject* OldFont;
        CDC* pDC;
      public:
        CUseDialogFont(CDC* _pDC) {pDC=_pDC; OldFont=pDC->SelectStockObject(ANSI_VAR_FONT);}
       ~CUseDialogFont()          {pDC->SelectObject(OldFont);}
      } Font(&dc);

      int tmp=Rect.left;
      Rect.left=0;
      dc.DrawText(s, Rect, DT_LEFT|DT_VCENTER|DT_SINGLELINE|DT_NOCLIP);
      Rect.right=tmp;  //Left hand side

      Region.DeleteObject();
      dc.SelectClipRgn(NULL);
      if(!Rect.right) return;
      BYTE R,G,B,H=(BYTE)(80*Scale*Rect.right),S=240,L=H+90;
      CHSL::HSL2RGB(R,G,B, H,S,L);
      dc.FillSolidRect(&Rect,RGB(R,G,B));

      R=-(H<24); //Make black or white text
      dc.SetTextColor(RGB(R,R,R));
      dc.DrawText(s, Rect, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
      return;
    }

    case Circle: {
      CPaintDC dc(this); // device context for painting
      BYTE R,G,B, H=(BYTE)(240*Scale*Rect.right),S=240,L=120;
      CHSL::HSL2RGB(R,G,B, H,S,L);
      CBrush Brush(RGB(R,G,B));
      CBrush* OldBrush=(CBrush*)dc.SelectObject(&Brush);
      CPen Pen(0,1,RGB(R,G,B));
      CPen* OldPen=(CPen*)dc.SelectObject(&Pen);
      CRect Rect1;
      GetClientRect(&Rect1);
      CPoint Point(
        (int)(-0.5+0.5*Rect1.right *(1+sin(3.14159265359*2*Scale*Rect.right))),
        (int)(-0.5+0.5*Rect1.bottom*(1+cos(3.14159265359*2*Scale*Rect.right)))
      );
      static CPoint Poly[3];
      static bool FirstPass=true;
      if(FirstPass) {
        FirstPass=false;
        Poly[0]=CPoint(Rect1.right/2, Rect1.bottom/2);
        Poly[1]=Poly[2]=Point;
      }
      if(Poly[1]!=Point) {
        Poly[2]=Point;
        dc.Polygon(Poly,3);
        Poly[1]=Point;
      }
      dc.SelectObject(OldBrush);
      dc.SelectObject(OldPen);
      return;
    }

    case Wheel: {
      CPaintDC dc(this); // device context for painting
      BYTE R,G,B, L=120;
      for(BYTE S=240; S<241; --S) {
        for(int A=0; A<=360; ++A) {
          double r=A*3.14159265359*2/360;
          BYTE H=(BYTE)(240/360.*A);
          CHSL::HSL2RGB(R,G,B, H,S,L);
          CPen Pen(0,2,RGB(R,G,B));
          CPen* OldPen=(CPen*)dc.SelectObject(&Pen);
          CRect Rect1;
          GetClientRect(&Rect1);
          CPoint Point(
            (int)(-0.5+0.5*Rect1.right +S*sin(r)),
            (int)(-0.5+0.5*Rect1.bottom+S*cos(r))
          );
          static CPoint LastPoint(Point);
          if(LastPoint!=Point) {
            dc.MoveTo(LastPoint);
            dc.LineTo(Point);
            LastPoint=Point;
          }
          dc.SelectObject(OldPen);
      } }
      Pos=Limit;
      return;
  } }
}
