// Status.h : header file

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef Statush
#define Statush

#include "MemDC.h"

class CStatus : public CWnd {
  CString Caption;
public:
  CStatus() : PixelLimit(0), Pos(0), Limit(0), Painter(Bar) {}

  enum Style {Bar,Circle,Wheel};

// Attributes
protected:
  Style Painter;
  WORD  PixelLimit;
  DWORD Limit;
  DWORD Pos;
 double PosScale;
 double Scale;
  CRect Rect;

  CBitmap Bitmap; //Used by CMemDC

// Operations
public:
  void SetWindowText(LPCSTR lpString)                     {Caption=lpString; Redraw();}
  int  GetWindowText(LPSTR lpString, int nMaxCount) const {return strlen(strncpy(lpString, Caption, nMaxCount));}
  void GetWindowText(CString& String)               const {String=Caption;}
  int  GetWindowTextLength()                        const {return Caption.GetLength();}
  void SetStyle(Style s) {Painter=s; Redraw();}
  void Clear() {
    Rect.right=0;
    Pos=0;
    Redraw();
  }
  void FindPixelLimit() {
    GetClientRect(&Rect);
    PixelLimit=(WORD)(Rect.right);
    Bitmap.CreateCompatibleBitmap(GetDC(), Rect.Width(), Rect.Height());
    Rect.right=0;
  }
  void SetLimit(DWORD b) {
    if(!PixelLimit) FindPixelLimit();
    Limit=b;
    PosScale=((double)PixelLimit)/Limit;
    Scale=1.0/PixelLimit;
    Clear();
  }
  void SetPos(DWORD p) {
    Pos=min(p, Limit);
    if(Rect.right==(int)(Pos*PosScale)) return;
       Rect.right= (int)(Pos*PosScale);
    Redraw();
  }
  void Move(long d=1) {
    Pos=min(Pos+d, Limit);
    if(Rect.right==(int)(Pos*PosScale)) return;
       Rect.right= (int)(Pos*PosScale);
    Redraw();
  }
  void Redraw() {if(IsWindow(m_hWnd)) RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);}
// Overrides
  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(CStatus)
  //}}AFX_VIRTUAL

// Implementation
public:
  virtual ~CStatus() {}

  // Generated message map functions
protected:
  //{{AFX_MSG(CStatus)
  afx_msg void OnPaint();
  afx_msg BOOL OnEraseBkgnd(CDC* pDC);
  //}}AFX_MSG

  DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // ndef Statush